function [H, magH2] = psdzac(F, rpoles, cpoles, rres, cres);
% calculates the transfer function H and abs(H).^2 of a discrete time filter for
% the frequency vector F. The real and complex poles and
% residues are the input. For every complex conjugate pair, only
% one pole (or residue) must exist in cpoles (and cres).

nrp = length(rpoles);
ncpp = length(cpoles);
H = F-F +1;
ejw = exp(2*pi*F*j);

for i=1:nrp,
  H = H + rres(i)./(ejw - rpoles(i) ) ;
end;

for i=1:ncpp,
  H = H + cres(i)./(ejw - cpoles(i) ) + conj(cres(i))./(ejw - conj(cpoles(i)) );
end;

magH2 = abs(H).^2;
